/*
*************************************************************************************
*                         			eGon
*					        Application Of eGon2.0
*
*				(c) Copyright 2006-2010, All winners Co,Ld.
*							All	Rights Reserved
*
* File Name 	: Board.c
*
* Author 		: javen
*
* Description 	: 
*
* History 		:
*      <author>    		<time>       	<version >    		<desc>
*       javen     	   2010-09-10          1.0            create this file
*
*************************************************************************************
*/

#include "include.h"

part_info_t           part_info;

typedef struct tag_CRC32_DATA
{
	unsigned int CRC;				//intĴС32λ
	unsigned int CRC_32_Tbl[256];	//
}CRC32_DATA_t;
/*
************************************************************************************************************
*
*                                             _calc_crc32
*
*    ƣ
*
*    б
*
*    ֵ  
*
*    ˵    
*
*
************************************************************************************************************
*/
static __u32 calc_crc32(void * buffer, __u32 length)
{
	__u32 i, j;
	CRC32_DATA_t crc32;		//
	__u32 CRC32 = 0xffffffff; //óʼֵ

	crc32.CRC = 0;

	for( i = 0; i < 256; ++i)//++iЧ
	{
		crc32.CRC = i;
		for( j = 0; j < 8 ; ++j)
		{
			//ѭʵϾ"㷨"ȡCRCУ
			if(crc32.CRC & 1)
				crc32.CRC = (crc32.CRC >> 1) ^ 0xEDB88320;
			else //0xEDB88320CRC-32ʽֵ
				crc32.CRC >>= 1;
		}
		crc32.CRC_32_Tbl[i] = crc32.CRC;
	}

	CRC32 = 0xffffffff; //óʼֵ
    for( i = 0; i < length; ++i)
    {
        CRC32 = crc32.CRC_32_Tbl[(CRC32^((unsigned char*)buffer)[i]) & 0xff] ^ (CRC32>>8);
    }

    //return CRC32;
	return CRC32^0xffffffff;
}
/*
************************************************************************************************************
*
*                                             _calc_crc32
*
*    ƣ
*
*    б
*
*    ֵ  
*
*    ˵    
*
*
************************************************************************************************************
*/
int check_private_part(int keyvalue)
{
	int   i;
	int   ret;
	__u32 crc;
	char  buffer[MBR_SIZE];
	MBR  *mbr_info;

	ret = update_flash_init();
	if(ret)
	{
		__inf("nand init failed\n");

		return -1;
	}
	memset(buffer, 0, MBR_SIZE);
	ret = update_flash_read(0, MBR_SIZE/512, buffer);
	if(ret)
	{
		__inf("nand read mbr failed\n");

		return -1;
	}
	mbr_info = (MBR *)buffer;
	crc = calc_crc32((void *)&mbr_info->version, sizeof(MBR) - 4);
	if(crc != mbr_info->crc32)
	{
		__inf("nand mbr is bad\n");

		return -1;
	}
	for(i=0;i<mbr_info->PartCount;i++)
	{
		if(strcmp(mbr_info->array[i].name, "private"))
		{
			continue;
		}
		else
		{
//			char buffer[32 * 1024];
//			int  len;
//			int  start;
//
//			__inf("ready to erase private part\n");
			part_info.addr = mbr_info->array[i].addrlo;
			part_info.len  = mbr_info->array[i].lenlo;
//			memset(buffer, 0xff, 32 * 1024);
//
//			len = part_info.len;
//			start = part_info.addr;
//			__inf("part size=%d\n", len);
//			__inf("part start=%x\n", start);
//			while(len >= 32 * 1024/512)
//			{
//				update_flash_write(start, 32 * 1024/512, buffer);
//				start += 32 * 1024/512;
//				len   -= 32 * 1024/512;
//			}
			__inf("ready to download private part\n");

			usb_start(1);
    		usb_run();

			break;
		}
	}
	if(i == mbr_info->PartCount)
	{
		__inf("there is no part called private\n");

		return -1;
	}

	update_flash_exit();

	return 0;
}


